from django.db import models
from clmainApp.models import User,HourSlot
from clbranchApp.models import Branch
from brpatientApp.models import Patient
from brfinanceApp.models import MedicalService
from brsessionApp.models import Session
# from django.db.models.signals import post_save
# from django.dispatch import receiver
# Create your models here.
############## Patient%Module #################
# icon لم يتم الحضور 
#<i class="fas fa-user-times"></i>
#<i class="fas fa-user-slash"></i>
#هتكون الحجوزات هنا زى dent shine 
#عندى فوق خالص إضافة حجز جديد زى سنتر بدر فى الجلسات tab بتفتح زى ملف المريض عند الدكتور 
#اول تاب : حجوزات  call center 
#تانى تاب : اضافة حجز جديد , مريض جه الفرع على طول , 
# الاولى هيطلع popup يختار الدكتور والخدمة العلاجية - السعر - المدفوع - المتبقى 
# وهياخد دور حسب ترتيب وصوله وممكن يكون فى زرار اشوف تفاصيل حجزه او ملاحظاته من الكول سينتر 
# التاب التانية هيظهر عندهم كل المرضى والدكتور والخدمة العلاجية والسعر وهياخد دوره حسب ترتيب وصوله 
# 
ENTRY_STATUS_CHOICES = (
    ("1I", "عند الدكتور"),#INSIDE
    ("2W", "انتظار"),# WAITING , MSTNI DOORO 
    ("3L", "تأخير"),# LATE , DOORO GEH W PATINET MSH MWGOD
    ("4F", "خروج"),#FINISHED VISIT , 5LS W MSHI
    # mmkn el case elli t7t di aw mmkn a7zfoo w5las 
    ("5C", "إلغاء"),# Cancel , geh 7agaz wmshi  w 3mltoo t25ir wmgash 5als aw geh w la8a w 5d floso 
    # reception status
    ("'8AT", "تأكيد الحضور"),
    ("9AB", " لم يتم الحضور "),
    ("10BC", "تم الحضور وإلغاء الحجز")
)
class PatientVisit(models.Model):
    visit_branch = models.ForeignKey(Branch,on_delete=models.PROTECT)   
    patient =  models.ForeignKey(
        Patient,
        related_name="PatientVisit_patient",
        on_delete=models.PROTECT,
    )
    medicalservice = models.ForeignKey(
        MedicalService,
        related_name="PatientVisit_MedicalService",
        blank=True,
        null=True,
        on_delete=models.PROTECT,
    )
    visit_day = models.DateField(blank=True,null=True)
    rcptn_notes = models.CharField(max_length=100,blank=True,null=True)#ملاحظات موظف الاستقبال أثناء الحجز 
    #entry_order = models.IntegerField(default=1000,help_text= " كل يوم جديد يبدأ من أول رقم 1  , ترتيب الدخول في الفترة الحالية")
    ms_cost = models.IntegerField(default=0)
    doctor_discount = models.IntegerField(default=0)
    voucher_discount = models.IntegerField(default=0)
    amount_required = models.IntegerField(default=0,help_text= "ثمن الخدمة العلاجية بعد تطبيق خصم نقابة او نسبة خصم لشركةاو بدون خصم")
    amount_paid = models.IntegerField(default=0,help_text= " المبلغ المدفوع < مقابل الخدمة العلاجية المقدمة>")
    related_payment = models.FloatField(default=0,help_text = (" المبلغ المدفوع < مقابل الخدمة العلاجية المقدمة>"))
    amount_remaining = models.IntegerField(default=0,help_text= " لو اتبقي علي المريض فلوس في الزيارة دي أو للمريض فلوس")
    doctor = models.ForeignKey(User,null=True,on_delete=models.PROTECT,related_name="PatientVisit_doctor",)
    created_by = models.ForeignKey(User,on_delete=models.PROTECT,related_name="PatientVisit_created_by",)
    created_at = models.DateTimeField(auto_now_add=True)
    entry_datetime = models.DateTimeField(blank=True,null=True)
    visit_status = models.CharField(max_length=4, choices=ENTRY_STATUS_CHOICES , default="2W")
    next_consult_date = models.DateField(blank=True,null=True)
    #الملاحظات اللى الدكتور بيكتبها لموظف الاستقبال عشان ياخد اجراء مع المريض بغد ما يخرج من عنده
    notes_for_rcptn = models.CharField(max_length=150,blank=True, null=True)
    is_confirmed = models.BooleanField(default=False)
    confirmed_by = models.ForeignKey(User,on_delete=models.PROTECT,null=True,related_name="PatientVisit_confirmed_by",)
    initial_slot = models.ForeignKey(HourSlot,on_delete=models.PROTECT,null=True,related_name="PatientVisit_initial_slot",)
    slots_count = models.IntegerField(default=0)
    current_visit_notes_dr = models.CharField(max_length=150,blank=True, null=True)
    next_visit_notes_dr = models.CharField(max_length=150,blank=True, null=True)
    #recommended_session =  models.ForeignKey(Session,on_delete=models.PROTECT,blank=True, null=True)
    #sessions_min = models.IntegerField(blank=True, null=True)
    #sessions_max = models.IntegerField(blank=True, null=True)
    is_debt_hide = models.BooleanField(default=False)
    last_updated_by = models.ForeignKey(User,on_delete=models.PROTECT, related_name='PatientVisit_last_updated_by',blank=True, null=True)
    updated_at = models.DateTimeField(blank=True, null=True)
    extra_visit_notes = models.CharField(max_length=150,blank=True, null=True)# will used for clarify visit_status

    # class Meta:
    #     unique_together = (('patient','visit_day',),('visit_day','visit_branch','entry_order'))
    def __str__(self):
        return "{}-{}".format(self.patient.fullname,self.medicalservice.name)

class PvPayment(models.Model):
    pv =  models.ForeignKey(
        PatientVisit,
        related_name="PvPayment_invoice",
        blank=True,
        null=True,
        on_delete=models.PROTECT,
    )
    amount_paid = models.IntegerField(default=0,help_text = (" المبلغ المدفوع < مقابل الخدمة العلاجية المقدمة>"))
    notes = models.CharField(max_length=50,blank=True,null=True)
    created_by = models.ForeignKey(User,on_delete=models.PROTECT)
    created_at = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return self.pv.patient.fullname
    
from django.db.models.signals import post_save
from django.dispatch import receiver
@receiver(post_save, sender=PvPayment)
def PvPayment_post_save(sender, instance, created, **kwargs):
    if created and instance.amount_paid > 0:
        pv = PatientVisit.objects.get(pk=instance.pv.pk)
        total_related_payment = pv.related_payment + instance.amount_paid
        pv.related_payment = total_related_payment
        pv.amount_remaining = pv.amount_required - ( pv.amount_paid + total_related_payment)
        pv.save()
from clmainApp.models import HourSlot
class PatientVisitSlot(models.Model):
    pv =  models.ForeignKey(
        PatientVisit,
        related_name="PatientVisitSlot_pv",
        blank=True,
        null=True,
        on_delete=models.PROTECT,
    )
    hour_slot = models.ForeignKey(HourSlot,null=True,on_delete=models.PROTECT,related_name="PatientVisitSlot_hour_slot",)#twe2eet el zyara
    class Meta:
        unique_together = ('pv', 'hour_slot',)

class PvDebt(models.Model):
    pv =  models.OneToOneField(
        PatientVisit,
        related_name="pv_debt",
        blank=True,
        null=True,
        on_delete=models.PROTECT,
    )
    notes = models.CharField(max_length=150,blank=True,null=True)
    updated_by = models.ForeignKey(User,on_delete=models.PROTECT, related_name='PvDebt_updated_by',blank=True, null=True)
    updated_at = models.DateTimeField(auto_now=True)

    def __str__(self):
        return self.pv.patient.fullname

'''
class ExtendPV_OX(models.Model):#("OX", "Oxygen"),
    pv =  models.OneToOneField(
        PatientVisit,
        related_name="ExtendPV_AG_pv",
        on_delete=models.PROTECT,
    )
    notes = models.TextField(blank=True, null=True)
    last_update_by = models.ForeignKey(User,on_delete=models.PROTECT)
    last_update_at = models.DateTimeField(auto_now=True)

    def __str__(self):
        return str(self.patient.fullname)

class ExtendPV_PN(models.Model):#("PN", "Pain"),
    pv =  models.OneToOneField(
        PatientVisit,
        related_name="ExtendPV_AG_pv",
        on_delete=models.PROTECT,
    )
    notes = models.TextField(blank=True, null=True)
    last_update_by = models.ForeignKey(User,on_delete=models.PROTECT)
    last_update_at = models.DateTimeField(auto_now=True)

    def __str__(self):
        return str(self.patient.fullname)

class ExtendPV_AG(models.Model):#("AG", "Andrology Genitourinary"),
    pv =  models.OneToOneField(
        PatientVisit,
        related_name="ExtendPV_AG_pv",
        on_delete=models.PROTECT,
    )
    notes = models.TextField(blank=True, null=True)
    def __str__(self):
        return str(self.patient.fullname)

'''